From 57c15109d1a4d45dedc06897d72722693aeef5b9 Mon Sep 17 00:00:00 2001
From: Ryan Goodfellow <ryan.goodfellow@oxide.computer>
Date: Mon, 30 Jan 2023 14:58:34 -0800
Subject: [PATCH] 17340 Want IPv6 Fast Path Portions contributed by: Patrick
 Mooney <pmooney@pfmooney.com> Portions contributed by: Kyle Simpson
 <kyle@oxide.computer> Portions contributed by: Ryan Zezeski
 <ryan@zinascii.com> Reviewed by: Ryan Zezeski <ryan@zinascii.com>

Change-Id: I561ab018a95b8540ebaf99355c747fa039e9f481
---
 usr/src/pkg/manifests/system-test-ostest.p5m  |   5 +
 usr/src/test/os-tests/tests/mac/Makefile      |  17 +-
 .../tests/mac/data/ipv4_tcp_lso_in.snoop      | Bin 0 -> 35900 bytes
 .../tests/mac/data/ipv4_tcp_lso_out.snoop     | Bin 0 -> 36176 bytes
 .../tests/mac/data/ipv6_tcp_lso_in.snoop      | Bin 0 -> 62624 bytes
 .../tests/mac/data/ipv6_tcp_lso_out.snoop     | Bin 0 -> 63296 bytes
 usr/src/test/os-tests/tests/mac/mac_cksum.c   | 209 +------
 usr/src/test/os-tests/tests/mac/mac_ktest.ksh |  47 +-
 .../os-tests/tests/mac/mac_ktest_common.c     | 198 +++++++
 .../os-tests/tests/mac/mac_ktest_common.h     |  76 +++
 usr/src/test/os-tests/tests/mac/mac_lso.c     | 214 ++++++++
 usr/src/uts/common/inet/ip/ip_if.c            |  18 +-
 usr/src/uts/common/inet/ip_impl.h             |  20 -
 usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c    |   7 +-
 usr/src/uts/common/io/dld/dld_proto.c         |  12 +-
 usr/src/uts/common/io/mac/mac_client.c        |  35 +-
 .../uts/common/io/mac/mac_datapath_setup.c    | 124 ++++-
 usr/src/uts/common/io/mac/mac_ktest.c         | 296 +++++++---
 usr/src/uts/common/io/mac/mac_sched.c         | 508 ++++++++++--------
 usr/src/uts/common/io/mac/mac_soft_ring.c     |   7 +
 usr/src/uts/common/io/mac/mac_stat.c          |  13 +-
 usr/src/uts/common/io/mac/mac_util.c          | 273 +++++-----
 usr/src/uts/common/os/ip_cksum.c              |   4 +-
 usr/src/uts/common/sys/mac_client_impl.h      |   4 +-
 usr/src/uts/common/sys/mac_client_priv.h      |   3 +-
 usr/src/uts/common/sys/mac_impl.h             |   8 +
 usr/src/uts/common/sys/mac_soft_ring.h        |  16 +-
 usr/src/uts/intel/io/viona/viona_rx.c         |  16 +-
 28 files changed, 1395 insertions(+), 735 deletions(-)
 create mode 100644 usr/src/test/os-tests/tests/mac/data/ipv4_tcp_lso_in.snoop
 create mode 100644 usr/src/test/os-tests/tests/mac/data/ipv4_tcp_lso_out.snoop
 create mode 100644 usr/src/test/os-tests/tests/mac/data/ipv6_tcp_lso_in.snoop
 create mode 100644 usr/src/test/os-tests/tests/mac/data/ipv6_tcp_lso_out.snoop
 create mode 100644 usr/src/test/os-tests/tests/mac/mac_ktest_common.c
 create mode 100644 usr/src/test/os-tests/tests/mac/mac_ktest_common.h
 create mode 100644 usr/src/test/os-tests/tests/mac/mac_lso.c

diff --git a/usr/src/pkg/manifests/system-test-ostest.p5m b/usr/src/pkg/manifests/system-test-ostest.p5m
index 16978c8d27..29cda51a3f 100644
--- a/usr/src/pkg/manifests/system-test-ostest.p5m
+++ b/usr/src/pkg/manifests/system-test-ostest.p5m
@@ -145,14 +145,19 @@ file path=opt/os-tests/tests/mac/data/ipv4_bad_proto.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv4_icmp.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv4_sctp.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv4_tcp.snoop mode=0444
+file path=opt/os-tests/tests/mac/data/ipv4_tcp_lso_in.snoop mode=0444
+file path=opt/os-tests/tests/mac/data/ipv4_tcp_lso_out.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv4_udp.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv6_eh_udp.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv6_icmp.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv6_sctp.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv6_tcp.snoop mode=0444
+file path=opt/os-tests/tests/mac/data/ipv6_tcp_lso_in.snoop mode=0444
+file path=opt/os-tests/tests/mac/data/ipv6_tcp_lso_out.snoop mode=0444
 file path=opt/os-tests/tests/mac/data/ipv6_udp.snoop mode=0444
 file path=opt/os-tests/tests/mac/mac_cksum mode=0555
 file path=opt/os-tests/tests/mac/mac_ktest mode=0555
+file path=opt/os-tests/tests/mac/mac_lso mode=0555
 file path=opt/os-tests/tests/mac/mac_parsing mode=0555
 dir  path=opt/os-tests/tests/minttl
 file path=opt/os-tests/tests/minttl/minttl mode=0555
diff --git a/usr/src/test/os-tests/tests/mac/Makefile b/usr/src/test/os-tests/tests/mac/Makefile
index 9a59fbca36..1f761464a9 100644
--- a/usr/src/test/os-tests/tests/mac/Makefile
+++ b/usr/src/test/os-tests/tests/mac/Makefile
@@ -13,7 +13,7 @@
 # Copyright 2025 Oxide Computer Company
 #
 
-include $(SRC)/Makefile.master
+include $(SRC)/Makefile.master.64
 
 ROOTOPTPKG = $(ROOT)/opt/os-tests
 TESTDIR = $(ROOTOPTPKG)/tests/mac
@@ -21,8 +21,11 @@ DATADIR = $(TESTDIR)/data
 
 PROGS = \
 	mac_cksum \
+	mac_lso \
 	mac_parsing
 
+COMMON_OBJS = mac_ktest_common.o
+
 SCRIPTS = mac_ktest
 
 DATAFILES = \
@@ -30,10 +33,14 @@ DATAFILES = \
 	ipv4_icmp.snoop \
 	ipv4_sctp.snoop \
 	ipv4_tcp.snoop \
+	ipv4_tcp_lso_in.snoop \
+	ipv4_tcp_lso_out.snoop \
 	ipv4_udp.snoop \
 	ipv6_icmp.snoop \
 	ipv6_sctp.snoop \
 	ipv6_tcp.snoop \
+	ipv6_tcp_lso_in.snoop \
+	ipv6_tcp_lso_out.snoop \
 	ipv6_udp.snoop \
 	ipv6_eh_udp.snoop
 
@@ -65,6 +72,14 @@ clobber: clean
 
 clean:
 
+mac_lso: mac_lso.o $(COMMON_OBJS)
+	$(LINK.c) $^ -o $@ $(LDLIBS)
+	$(POST_PROCESS)
+
+mac_cksum: mac_cksum.o $(COMMON_OBJS)
+	$(LINK.c) $^ -o $@ $(LDLIBS)
+	$(POST_PROCESS)
+
 $(CMDS): $(TESTDIR) $(PROGS)
 
 $(TESTDIR):
diff --git a/usr/src/test/os-tests/tests/mac/mac_cksum.c b/usr/src/test/os-tests/tests/mac/mac_cksum.c
index 3fe91445ba..86746b44b6 100644
--- a/usr/src/test/os-tests/tests/mac/mac_cksum.c
+++ b/usr/src/test/os-tests/tests/mac/mac_cksum.c
@@ -28,182 +28,21 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <fcntl.h>
-#include <unistd.h>
 #include <err.h>
 #include <errno.h>
-#include <strings.h>
-#include <netinet/in.h>
-#include <sys/mman.h>
-#include <sys/dlpi.h>
-#include <sys/types.h>
-#include <sys/types32.h>
-#include <sys/stat.h>
-#include <sys/sysmacros.h>
-#include <sys/ethernet.h>
+#include <libgen.h>
 
-#include <libnvpair.h>
 #include <libktest.h>
 
-typedef struct snoop_pkt_hdr {
-	uint_t			sph_origlen;
-	uint_t			sph_msglen;
-	uint_t			sph_totlen;
-	uint_t			sph_drops;
-#if defined(_LP64)
-	struct timeval32	sph_timestamp;
-#else
-#error	"ktest is expected to be 64-bit for now"
-#endif
-} snoop_pkt_hdr_t;
-
-typedef struct snoop_file_hdr {
-	char		sfh_magic[8];
-	uint32_t	sfh_vers;
-	uint32_t	sfh_mac_type;
-} snoop_file_hdr_t;
-
-static const char snoop_magic[8] = "snoop\0\0\0";
-static const uint_t snoop_acceptable_vers = 2;
-
-typedef struct pkt_cap_iter {
-	int		pci_fd;
-	const char	*pci_base;
-	size_t		pci_map_sz;
-	size_t		pci_sz;
-	size_t		pci_offset;
-} pkt_cap_iter_t;
-
-static pkt_cap_iter_t *
-pkt_cap_open(int fd)
-{
-	struct stat info;
-	if (fstat(fd, &info) != 0) {
-		return (NULL);
-	}
-	if (info.st_size < sizeof (snoop_file_hdr_t)) {
-		errno = EINVAL;
-		return (NULL);
-	}
-
-	const size_t page_sz = (size_t)sysconf(_SC_PAGESIZE);
-	const size_t map_sz = P2ROUNDUP(info.st_size, page_sz);
-	void *map = mmap(NULL, map_sz, PROT_READ, MAP_PRIVATE, fd, 0);
-	if (map == NULL) {
-		return (NULL);
-	}
-
-	const snoop_file_hdr_t *hdr = (const snoop_file_hdr_t *)map;
-	if (bcmp(&hdr->sfh_magic, snoop_magic, sizeof (hdr->sfh_magic)) != 0 ||
-	    ntohl(hdr->sfh_vers) != snoop_acceptable_vers ||
-	    ntohl(hdr->sfh_mac_type) != DL_ETHER) {
-		(void) munmap(map, map_sz);
-		errno = EINVAL;
-		return (NULL);
-	}
-
-	struct pkt_cap_iter *iter = malloc(sizeof (struct pkt_cap_iter));
-	if (iter == NULL) {
-		(void) munmap(map, map_sz);
-		errno = ENOMEM;
-		return (NULL);
-	}
-
-	iter->pci_fd = fd;
-	iter->pci_base = (const char *)map;
-	iter->pci_map_sz = map_sz;
-	iter->pci_sz = info.st_size;
-	iter->pci_offset = sizeof (*hdr);
-
-	return (iter);
-}
-
-static void
-pkt_cap_close(pkt_cap_iter_t *iter)
-{
-	(void) munmap((void *)iter->pci_base, iter->pci_map_sz);
-	(void) close(iter->pci_fd);
-	free(iter);
-}
-
-static bool
-pkt_cap_next(pkt_cap_iter_t *iter, const void **pkt_buf, uint_t *sizep)
-{
-	size_t remain = iter->pci_sz - iter->pci_offset;
-
-	if (remain < sizeof (snoop_pkt_hdr_t)) {
-		return (false);
-	}
-
-	const snoop_pkt_hdr_t *hdr =
-	    (const snoop_pkt_hdr_t *)&iter->pci_base[iter->pci_offset];
-
-	const uint_t msg_sz = ntohl(hdr->sph_msglen);
-	const uint_t total_sz = ntohl(hdr->sph_totlen);
-	if (remain < total_sz || remain < msg_sz) {
-		return (false);
-	}
-
-	*pkt_buf = (const void *)&hdr[1];
-	*sizep = msg_sz;
-	iter->pci_offset += total_sz;
-	return (true);
-}
+#include "mac_ktest_common.h"
 
 static ktest_hdl_t *kthdl = NULL;
 const char *mac_cksum_cmd = "";
 
-struct payload_opts {
-	uint_t		po_padding;
-	boolean_t	po_cksum_partial;
-	boolean_t	po_cksum_full;
-	boolean_t	po_cksum_ipv4;
-	boolean_t	po_split_ether;
-	uint_t		po_split_manual;
-};
-
-static char *
-build_payload(const void *pkt_buf, uint_t pkt_sz,
-    const struct payload_opts *popts, size_t *payload_sz)
-{
-	nvlist_t *payload = fnvlist_alloc();
-	fnvlist_add_byte_array(payload, "pkt_bytes",
-	    (uchar_t *)pkt_buf, pkt_sz);
-	if (popts->po_padding) {
-		fnvlist_add_uint32(payload, "padding", popts->po_padding);
-	}
-	if (popts->po_cksum_partial) {
-		fnvlist_add_boolean(payload, "cksum_partial");
-	}
-	if (popts->po_cksum_full) {
-		fnvlist_add_boolean(payload, "cksum_full");
-	}
-	if (popts->po_cksum_ipv4) {
-		fnvlist_add_boolean(payload, "cksum_ipv4");
-	}
-
-	uint_t nsplit = 0;
-	uint32_t splits[2];
-	if (popts->po_split_ether) {
-		splits[nsplit++] = sizeof (struct ether_header);
-	}
-	if (popts->po_split_manual != 0) {
-		splits[nsplit++] = popts->po_split_manual;
-	}
-	if (nsplit > 0) {
-		fnvlist_add_uint32_array(payload, "cksum_splits", splits,
-		    nsplit);
-	}
-
-	char *packed = fnvlist_pack(payload, payload_sz);
-	nvlist_free(payload);
-
-	return (packed);
-}
-
-static void
+static void __NORETURN
 mac_cksum_usage(void)
 {
-	(void) fprintf(stderr, "usage: %s [flags] [opts] <cap_file>\n\n"
+	(void) fprintf(stderr, "Usage: %s [flags] [opts] <cap_file>\n\n"
 	    "Flags:\n"
 	    "\t-4\temulate HCK_IPV4_HDRCKSUM\n"
 	    "\t-f\temulate HCK_FULLCKSUM\t(cannot be used with -p)\n"
@@ -226,10 +65,11 @@ int
 main(int argc, char *argv[])
 {
 	/* Peel off command name for usage */
-	mac_cksum_cmd = argv[0];
+	mac_cksum_cmd = basename(argv[0]);
 	argc--;
 	argv++;
 	optind = 0;
+	const char *errstr = NULL;
 
 	struct payload_opts popts = { 0 };
 	int c;
@@ -245,27 +85,29 @@ main(int argc, char *argv[])
 			popts.po_cksum_ipv4 = B_TRUE;
 			break;
 		case 'b':
-			errno = 0;
-			popts.po_padding = strtoul(optarg, NULL, 0);
-			if (errno != 0) {
-				err(EXIT_FAILURE,
-				    "invalid padding value %s", optarg);
+			popts.po_padding =
+			    strtonumx(optarg, 0, UINT16_MAX, &errstr, 0);
+			if (errstr != NULL) {
+				errx(EXIT_FAILURE,
+				    "invalid padding value %s: %s",
+				    optarg, errstr);
 			}
 			break;
 		case 'e':
 			popts.po_split_ether = B_TRUE;
 			break;
 		case 's':
-			errno = 0;
-			popts.po_split_manual = strtoul(optarg, NULL, 0);
-			if (errno != 0) {
-				err(EXIT_FAILURE,
-				    "invalid split value %s", optarg);
+			popts.po_split_manual =
+			    strtonumx(optarg, 0, UINT16_MAX, &errstr, 0);
+			if (errstr != NULL) {
+				errx(EXIT_FAILURE,
+				    "invalid split value %s: %s",
+				    optarg, errstr);
 			}
 			break;
 
 		case '?':
-			warnx("unknown run option: -%c", optopt);
+			warnx("unknown option: -%c", optopt);
 			mac_cksum_usage();
 		}
 	}
@@ -273,10 +115,11 @@ main(int argc, char *argv[])
 	argv += optind;
 
 	if (argc != 1) {
+		(void) fprintf(stderr, "cap_file is a required argument\n");
 		mac_cksum_usage();
 	}
 
-	int fd = open(argv[0], O_RDONLY, 0);
+	int fd = open(argv[0], O_RDONLY);
 	if (fd < 0) {
 		err(EXIT_FAILURE, "could not open cap file %s", argv[0]);
 	}
@@ -286,12 +129,12 @@ main(int argc, char *argv[])
 		err(EXIT_FAILURE, "unrecognized cap file %s", argv[0]);
 	}
 
-	if (!ktest_mod_load("mac")) {
-		err(EXIT_FAILURE, "could not load mac ktest module");
-	}
 	if ((kthdl = ktest_init()) == NULL) {
 		err(EXIT_FAILURE, "could not initialize libktest");
 	}
+	if (!ktest_mod_load("mac")) {
+		err(EXIT_FAILURE, "could not load mac ktest module");
+	}
 
 	const void *pkt_buf;
 	uint_t pkt_sz;
@@ -303,8 +146,8 @@ main(int argc, char *argv[])
 			.krq_test = "mac_sw_cksum_test",
 		};
 		size_t payload_sz;
-		char *payload =
-		    build_payload(pkt_buf, pkt_sz, &popts, &payload_sz);
+		char *payload = build_payload(pkt_buf, pkt_sz, NULL, 0,
+		    &popts, &payload_sz);
 		req.krq_input = (uchar_t *)payload;
 		req.krq_input_len = (uint_t)payload_sz;
 
diff --git a/usr/src/test/os-tests/tests/mac/mac_ktest.ksh b/usr/src/test/os-tests/tests/mac/mac_ktest.ksh
index 278ec355ef..cb00771623 100644
--- a/usr/src/test/os-tests/tests/mac/mac_ktest.ksh
+++ b/usr/src/test/os-tests/tests/mac/mac_ktest.ksh
@@ -19,16 +19,23 @@ unalias -a
 mac_test_dir="$(dirname $0)"
 mac_data_dir="$mac_test_dir/data"
 mac_cksum="$mac_test_dir/mac_cksum"
+mac_lso="$mac_test_dir/mac_lso"
 mac_exit=0
 
 run_one()
 {
-	typeset input="$mac_data_dir/$1"
-	shift
+	typeset prog="$1"
+	typeset input="$mac_data_dir/$2"
+	shift 2
 
-	echo "$mac_cksum $* $input"
-	$mac_cksum $* $input
-	if (( $? != 0 )); then
+	typeset output=""
+	if [[ $prog == $mac_lso ]]; then
+		output="$mac_data_dir/$1"
+		shift
+	fi
+
+	echo "$prog $* $input $output"
+	if ! $prog $* $input $output; then
 		mac_exit=1
 	fi
 }
@@ -45,24 +52,40 @@ run_test()
 	run_one $* -e -s 8
 }
 
+run_cso()
+{
+	run_test $mac_cksum $*
+}
+
+run_lso()
+{
+	run_test $mac_lso $*
+}
+
 # The bad-L4-proto case should only try getting a IPv4 checksum.
 # It would fail to get an L4 checksum
-run_test ipv4_bad_proto.snoop -4
+run_cso ipv4_bad_proto.snoop -4
 
 ipv4_cases="ipv4_icmp.snoop ipv4_tcp.snoop ipv4_udp.snoop"
 for c in $ipv4_cases; do
-	run_test $c -4 -p
-	run_test $c -4 -f
+	run_cso $c -4 -p
+	run_cso $c -4 -f
 done
 
 ipv6_cases="ipv6_icmp.snoop ipv6_tcp.snoop ipv6_udp.snoop ipv6_eh_udp.snoop"
 for c in $ipv6_cases; do
-	run_test $c -p
-	run_test $c -f
+	run_cso $c -p
+	run_cso $c -f
 done
 
 # Only full checksums are supported for SCTP
-run_test "ipv4_sctp.snoop" -4 -f
-run_test "ipv6_sctp.snoop" -f
+run_cso "ipv4_sctp.snoop" -4 -f
+run_cso "ipv6_sctp.snoop" -f
+
+# Only TCP is supported for LSO.
+run_lso "ipv4_tcp_lso_in.snoop" "ipv4_tcp_lso_out.snoop" -4 -f -m 8948
+run_lso "ipv4_tcp_lso_in.snoop" "ipv4_tcp_lso_out.snoop" -4 -p -m 8948
+run_lso "ipv6_tcp_lso_in.snoop" "ipv6_tcp_lso_out.snoop" -f -m 8928
+run_lso "ipv6_tcp_lso_in.snoop" "ipv6_tcp_lso_out.snoop" -p -m 8928
 
 exit $mac_exit
diff --git a/usr/src/test/os-tests/tests/mac/mac_ktest_common.c b/usr/src/test/os-tests/tests/mac/mac_ktest_common.c
new file mode 100644
index 0000000000..331270f174
--- /dev/null
+++ b/usr/src/test/os-tests/tests/mac/mac_ktest_common.c
@@ -0,0 +1,198 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2025 Oxide Computer Compnay
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <fcntl.h>
+#include <unistd.h>
+#include <err.h>
+#include <errno.h>
+#include <strings.h>
+#include <netinet/in.h>
+#include <sys/mman.h>
+#include <sys/dlpi.h>
+#include <sys/stat.h>
+#include <sys/sysmacros.h>
+#include <sys/ethernet.h>
+
+#include <libnvpair.h>
+
+#include "mac_ktest_common.h"
+
+static const char snoop_magic[8] = "snoop\0\0\0";
+static const uint_t snoop_acceptable_vers = 2;
+
+pkt_cap_iter_t *
+pkt_cap_open(int fd)
+{
+	struct stat info;
+	if (fstat(fd, &info) != 0) {
+		return (NULL);
+	}
+	if (info.st_size < sizeof (snoop_file_hdr_t)) {
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	const size_t page_sz = (size_t)sysconf(_SC_PAGESIZE);
+	const size_t map_sz = P2ROUNDUP(info.st_size, page_sz);
+	void *map = mmap(NULL, map_sz, PROT_READ, MAP_PRIVATE, fd, 0);
+	if (map == NULL) {
+		return (NULL);
+	}
+
+	const snoop_file_hdr_t *hdr = (const snoop_file_hdr_t *)map;
+	if (bcmp(&hdr->sfh_magic, snoop_magic, sizeof (hdr->sfh_magic)) != 0 ||
+	    ntohl(hdr->sfh_vers) != snoop_acceptable_vers ||
+	    ntohl(hdr->sfh_mac_type) != DL_ETHER) {
+		(void) munmap(map, map_sz);
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	struct pkt_cap_iter *iter = malloc(sizeof (struct pkt_cap_iter));
+	if (iter == NULL) {
+		(void) munmap(map, map_sz);
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	iter->pci_fd = fd;
+	iter->pci_base = (const char *)map;
+	iter->pci_map_sz = map_sz;
+	iter->pci_sz = info.st_size;
+	iter->pci_offset = sizeof (*hdr);
+
+	return (iter);
+}
+
+void
+pkt_cap_close(pkt_cap_iter_t *iter)
+{
+	(void) munmap((void *)iter->pci_base, iter->pci_map_sz);
+	(void) close(iter->pci_fd);
+	free(iter);
+}
+
+void
+pkt_cap_reset(pkt_cap_iter_t *iter)
+{
+	iter->pci_offset = sizeof (snoop_file_hdr_t);
+}
+
+bool
+pkt_cap_next(pkt_cap_iter_t *iter, const void **pkt_buf, uint_t *sizep)
+{
+	size_t remain = iter->pci_sz - iter->pci_offset;
+
+	if (remain < sizeof (snoop_pkt_hdr_t)) {
+		return (false);
+	}
+
+	const snoop_pkt_hdr_t *hdr =
+	    (const snoop_pkt_hdr_t *)&iter->pci_base[iter->pci_offset];
+
+	const uint_t msg_sz = ntohl(hdr->sph_msglen);
+	const uint_t total_sz = ntohl(hdr->sph_totlen);
+	if (remain < total_sz || remain < msg_sz) {
+		return (false);
+	}
+
+	*pkt_buf = (const void *)&hdr[1];
+	*sizep = msg_sz;
+	iter->pci_offset += total_sz;
+	return (true);
+}
+
+char *
+serialize_pkt_chain(pkt_cap_iter_t *iter, uint_t *sizep)
+{
+	/*
+	 * First, figure out how many bytes are needed. We're serializing
+	 * down to `uint32_t` (len) + <bytes> for each packet.
+	 */
+	const void *pkt_buf = NULL;
+	*sizep = 0;
+	uint_t pkt_sz;
+	while (pkt_cap_next(iter, &pkt_buf, &pkt_sz)) {
+		*sizep += sizeof (uint32_t) + pkt_sz;
+	}
+
+	/*
+	 * Rewalk, and copy all the bytes out.
+	 */
+	char *out = malloc(*sizep);
+	pkt_cap_reset(iter);
+
+	if (out == NULL)
+		return (out);
+	char *cur = out;
+	while (pkt_cap_next(iter, &pkt_buf, &pkt_sz)) {
+		uint32_t ps = pkt_sz;
+		bcopy(&ps, cur, sizeof (ps));
+		cur += sizeof (ps);
+		bcopy(pkt_buf, cur, pkt_sz);
+		cur += pkt_sz;
+	}
+
+	return (out);
+}
+
+char *
+build_payload(const void *pkt_buf, uint_t pkt_sz,
+    const void *out_pkt_buf, uint_t out_pkt_sz,
+    const struct payload_opts *popts, size_t *payload_sz)
+{
+	nvlist_t *payload = fnvlist_alloc();
+	fnvlist_add_byte_array(payload, "pkt_bytes",
+	    (uchar_t *)pkt_buf, pkt_sz);
+	if (out_pkt_buf != NULL) {
+		fnvlist_add_byte_array(payload, "out_pkt_bytes",
+		    (uchar_t *)out_pkt_buf, out_pkt_sz);
+	}
+	if (popts->po_mss) {
+		fnvlist_add_uint32(payload, "mss", popts->po_mss);
+	}
+	if (popts->po_padding) {
+		fnvlist_add_uint32(payload, "padding", popts->po_padding);
+	}
+	if (popts->po_cksum_partial) {
+		fnvlist_add_boolean(payload, "cksum_partial");
+	}
+	if (popts->po_cksum_full) {
+		fnvlist_add_boolean(payload, "cksum_full");
+	}
+	if (popts->po_cksum_ipv4) {
+		fnvlist_add_boolean(payload, "cksum_ipv4");
+	}
+
+	uint_t nsplit = 0;
+	uint32_t splits[2];
+	if (popts->po_split_ether) {
+		splits[nsplit++] = sizeof (struct ether_header);
+	}
+	if (popts->po_split_manual != 0) {
+		splits[nsplit++] = popts->po_split_manual;
+	}
+	if (nsplit > 0) {
+		fnvlist_add_uint32_array(payload, "cksum_splits", splits,
+		    nsplit);
+	}
+
+	char *packed = fnvlist_pack(payload, payload_sz);
+	nvlist_free(payload);
+
+	return (packed);
+}
diff --git a/usr/src/test/os-tests/tests/mac/mac_ktest_common.h b/usr/src/test/os-tests/tests/mac/mac_ktest_common.h
new file mode 100644
index 0000000000..885bb7bd13
--- /dev/null
+++ b/usr/src/test/os-tests/tests/mac/mac_ktest_common.h
@@ -0,0 +1,76 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2025 Oxide Computer Compnay
+ */
+
+#ifndef _MAC_KTEST_COMMON_H
+#define	_MAC_KTEST_COMMON_H
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+#include <sys/stdbool.h>
+#include <sys/types.h>
+#include <sys/types32.h>
+
+typedef struct snoop_pkt_hdr {
+	uint32_t		sph_origlen;
+	uint32_t		sph_msglen;
+	uint32_t		sph_totlen;
+	uint32_t		sph_drops;
+#if defined(_LP64)
+	struct timeval32	sph_timestamp;
+#else
+#error	"ktest is expected to be 64-bit for now"
+#endif
+} snoop_pkt_hdr_t;
+
+typedef struct snoop_file_hdr {
+	char		sfh_magic[8];
+	uint32_t	sfh_vers;
+	uint32_t	sfh_mac_type;
+} snoop_file_hdr_t;
+
+typedef struct pkt_cap_iter {
+	int		pci_fd;
+	const char	*pci_base;
+	size_t		pci_map_sz;
+	size_t		pci_sz;
+	size_t		pci_offset;
+} pkt_cap_iter_t;
+
+extern pkt_cap_iter_t *pkt_cap_open(int);
+extern void pkt_cap_close(pkt_cap_iter_t *);
+extern void pkt_cap_reset(pkt_cap_iter_t *);
+extern bool pkt_cap_next(pkt_cap_iter_t *, const void **, uint_t *);
+
+struct payload_opts {
+	uint_t		po_padding;
+	boolean_t	po_cksum_partial;
+	boolean_t	po_cksum_full;
+	boolean_t	po_cksum_ipv4;
+	boolean_t	po_split_ether;
+	uint_t		po_split_manual;
+	uint_t		po_mss;
+};
+
+extern char *build_payload(const void *, uint_t, const void *, uint_t,
+    const struct payload_opts *, size_t *);
+extern char *serialize_pkt_chain(pkt_cap_iter_t *iter, uint_t *sizep);
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif /* _MAC_KTEST_COMMON_H */
diff --git a/usr/src/test/os-tests/tests/mac/mac_lso.c b/usr/src/test/os-tests/tests/mac/mac_lso.c
new file mode 100644
index 0000000000..e84e9e82a8
--- /dev/null
+++ b/usr/src/test/os-tests/tests/mac/mac_lso.c
@@ -0,0 +1,214 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2025 Oxide Computer Compnay
+ */
+
+/*
+ * Executor for mac_sw_lso() ktests.
+ *
+ * This program builds up the packed nvlist payloads expected by the ktest for
+ * mac_sw_lso().  The caller provides a snoop(1) with one packet, which may not
+ * have valid checksums. This operates the runner similarly to mac_cksum:
+ * required checksum types are specified via option flags, and the output mblk
+ * chain is compared byte-for-byte with equality against a separate output
+ * snoop file.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <fcntl.h>
+#include <err.h>
+#include <errno.h>
+#include <libgen.h>
+
+#include <libktest.h>
+
+#include "mac_ktest_common.h"
+
+static ktest_hdl_t *kthdl = NULL;
+const char *mac_lso_cmd = "";
+
+static void __NORETURN
+mac_lso_usage(void)
+{
+	(void) fprintf(stderr, "Usage: %s [flags] [opts] <cap_file_in> "
+	    "<cap_file_out>\n\n"
+	    "Flags:\n"
+	    "\t-4\temulate HCK_IPV4_HDRCKSUM\n"
+	    "\t-f\temulate HCK_FULLCKSUM\t(cannot be used with -p)\n"
+	    "\t-p\temulate HCK_PARTIALCKSUM\t(cannot be used with -f)\n"
+	    "\t\t\tOne of -f/-p *must* be provided.\n"
+	    "\t-e\tsplit mblk after Ethernet header\n"
+	    "Options:\n"
+	    "\t-b <len>\tpad mblk with <len> bytes (must be even)\n"
+	    "\t-s <len>\tsplit mblk after len bytes (must be even)\n"
+	    "\t\t\tif -e is specified, will be applied after that split\n"
+	    "\t-m <len>\tmaximum segment size for LSO (default 1448)\n"
+	    "Arguments:\n"
+	    "\t<cap_file_in> is a snoop capture containing one test packet.\n"
+	    "\t<cap_file_out> is a snoop capture of expected output packets.\n"
+	    "\tInput packets may or may not have filled L3/L4 checksums, as\n"
+	    "\tclients will have different expectations about which\n",
+	    "\tchecksum offloads are available.\n",
+	    mac_lso_cmd);
+	exit(EXIT_FAILURE);
+}
+
+int
+main(int argc, char *argv[])
+{
+	/* Peel off command name for usage */
+	mac_lso_cmd = basename(argv[0]);
+	argc--;
+	argv++;
+	optind = 0;
+	const char *errstr = NULL;
+
+	struct payload_opts popts = {
+		.po_mss = 1448
+	};
+	int c;
+	while ((c = getopt(argc, argv, "4fpeb:s:m:")) != -1) {
+		switch (c) {
+		case 'p':
+			popts.po_cksum_partial = B_TRUE;
+			break;
+		case 'f':
+			popts.po_cksum_full = B_TRUE;
+			break;
+		case '4':
+			popts.po_cksum_ipv4 = B_TRUE;
+			break;
+		case 'b':
+			popts.po_padding =
+			    strtonumx(optarg, 0, UINT16_MAX, &errstr, 0);
+			if (errstr != NULL) {
+				errx(EXIT_FAILURE,
+				    "invalid padding value %s: %s",
+				    optarg, errstr);
+			}
+			break;
+		case 'e':
+			popts.po_split_ether = B_TRUE;
+			break;
+		case 's':
+			popts.po_split_manual =
+			    strtonumx(optarg, 0, UINT16_MAX, &errstr, 0);
+			if (errstr != NULL) {
+				errx(EXIT_FAILURE,
+				    "invalid split value %s: %s",
+				    optarg, errstr);
+			}
+			break;
+		case 'm':
+			popts.po_mss =
+			    strtonumx(optarg, 0, UINT32_MAX, &errstr, 0);
+			if (errstr != NULL) {
+				errx(EXIT_FAILURE,
+				    "invalid MSS value %s: %s",
+				    optarg, errstr);
+			}
+			break;
+
+		case '?':
+			warnx("unknown option: -%c", optopt);
+			mac_lso_usage();
+		}
+	}
+	argc -= optind;
+	argv += optind;
+
+	if (argc != 2) {
+		(void) fprintf(stderr,
+		    "cap_file_in and cap_file_out are required arguments\n");
+		mac_lso_usage();
+	}
+
+	if (popts.po_cksum_full == popts.po_cksum_partial) {
+		errx(EXIT_FAILURE, "specify exactly one of -f/-p");
+	}
+
+	int in_fd = open(argv[0], O_RDONLY);
+	if (in_fd < 0) {
+		err(EXIT_FAILURE, "could not open input cap file %s", argv[0]);
+	}
+
+	int out_fd = open(argv[1], O_RDONLY);
+	if (out_fd < 0) {
+		err(EXIT_FAILURE, "could not open output cap file %s", argv[0]);
+	}
+
+	pkt_cap_iter_t *in_iter = pkt_cap_open(in_fd);
+	if (in_iter == NULL) {
+		err(EXIT_FAILURE, "unrecognized cap file %s", argv[0]);
+	}
+
+	pkt_cap_iter_t *out_iter = pkt_cap_open(out_fd);
+	if (out_iter == NULL) {
+		err(EXIT_FAILURE, "unrecognized cap file %s", argv[1]);
+	}
+
+	const void *pkt_buf = NULL;
+	uint_t pkt_sz;
+	if (!pkt_cap_next(in_iter, &pkt_buf, &pkt_sz)) {
+		err(EXIT_FAILURE, "no packets in input capture");
+	}
+
+	uint_t out_pkt_sz;
+	char *out_pkt_buf = serialize_pkt_chain(out_iter, &out_pkt_sz);
+	if (out_pkt_buf == NULL) {
+		err(EXIT_FAILURE, "failed to read output packet stream");
+	}
+
+	if ((kthdl = ktest_init()) == NULL) {
+		err(EXIT_FAILURE, "could not initialize libktest");
+	}
+	if (!ktest_mod_load("mac")) {
+		err(EXIT_FAILURE, "could not load mac ktest module");
+	}
+
+	ktest_run_req_t req = {
+		.krq_module = "mac",
+		.krq_suite = "lso",
+		.krq_test = "mac_sw_lso_test",
+	};
+	size_t payload_sz;
+	char *payload =
+	    build_payload(pkt_buf, pkt_sz, out_pkt_buf, out_pkt_sz, &popts,
+	    &payload_sz);
+	req.krq_input = (uchar_t *)payload;
+	req.krq_input_len = (uint_t)payload_sz;
+
+	ktest_run_result_t result = { 0 };
+	if (!ktest_run(kthdl, &req, &result)) {
+		err(EXIT_FAILURE, "failure while attempting ktest run");
+	}
+	free(payload);
+	free(out_pkt_buf);
+
+	const char *code_name = ktest_code_name(result.krr_code);
+	(void) printf("%s\t(len: %u)\n", code_name, pkt_sz);
+	if (result.krr_msg != NULL) {
+		if (result.krr_code != KTEST_CODE_PASS) {
+			(void) printf("MSG: %s\n", result.krr_msg);
+		}
+		free(result.krr_msg);
+	}
+
+	pkt_cap_close(in_iter);
+	pkt_cap_close(out_iter);
+	ktest_fini(kthdl);
+
+	return (result.krr_code == KTEST_CODE_PASS ? EXIT_SUCCESS :
+	    EXIT_FAILURE);
+}
diff --git a/usr/src/uts/common/inet/ip/ip_if.c b/usr/src/uts/common/inet/ip/ip_if.c
index 5b0f3fd565..b3910373a4 100644
--- a/usr/src/uts/common/inet/ip/ip_if.c
+++ b/usr/src/uts/common/inet/ip/ip_if.c
@@ -24,7 +24,7 @@
  * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright (c) 2016, Joyent, Inc. All rights reserved.
  * Copyright (c) 2014, OmniTI Computer Consulting, Inc. All rights reserved.
- * Copyright 2023 Oxide Computer Company
+ * Copyright 2025 Oxide Computer Company
  */
 
 /*
@@ -2011,10 +2011,14 @@ ill_capability_direct_enable(ill_t *ill)
 	dld_capab_direct_t	direct;
 	int			rc;
 
-	ASSERT(!ill->ill_isv6 && IAM_WRITER_ILL(ill));
+	ASSERT(IAM_WRITER_ILL(ill));
 
 	bzero(&direct, sizeof (direct));
-	direct.di_rx_cf = (uintptr_t)ip_input;
+	if (ill->ill_isv6) {
+		direct.di_rx_cf = (uintptr_t)ip_input_v6;
+	} else {
+		direct.di_rx_cf = (uintptr_t)ip_input;
+	}
 	direct.di_rx_ch = ill;
 
 	rc = idc->idc_capab_df(idc->idc_capab_dh, DLD_CAPAB_DIRECT, &direct,
@@ -2050,7 +2054,7 @@ ill_capability_poll_enable(ill_t *ill)
 	dld_capab_poll_t	poll;
 	int			rc;
 
-	ASSERT(!ill->ill_isv6 && IAM_WRITER_ILL(ill));
+	ASSERT(IAM_WRITER_ILL(ill));
 
 	bzero(&poll, sizeof (poll));
 	poll.poll_ring_add_cf = (uintptr_t)ip_squeue_add_ring;
@@ -2118,10 +2122,8 @@ ill_capability_dld_enable(ill_t *ill)
 	ASSERT(IAM_WRITER_ILL(ill));
 
 	ill_mac_perim_enter(ill, &mph);
-	if (!ill->ill_isv6) {
-		ill_capability_direct_enable(ill);
-		ill_capability_poll_enable(ill);
-	}
+	ill_capability_direct_enable(ill);
+	ill_capability_poll_enable(ill);
 	ill_capability_lso_enable(ill);
 	ill->ill_capabilities |= ILL_CAPAB_DLD;
 	ill_mac_perim_exit(ill, mph);
diff --git a/usr/src/uts/common/inet/ip_impl.h b/usr/src/uts/common/inet/ip_impl.h
index 36d53ef016..b51e2de376 100644
--- a/usr/src/uts/common/inet/ip_impl.h
+++ b/usr/src/uts/common/inet/ip_impl.h
@@ -169,26 +169,6 @@ extern "C" {
 #define	ILL_DIRECT_CAPABLE(ill)						\
 	(((ill)->ill_capabilities & ILL_CAPAB_DLD_DIRECT) != 0)
 
-/*
- * Determine if a mblk needs to take the "slow path", aka OTH
- * softring. There are multiple reasons why a mblk might take the slow
- * path.
- *
- * o The mblk is not a data message.
- *
- * o There is more than one outstanding reference to the mblk.
- *
- * o The IP header is not aligned (we assume alignment in the checksum
- *   routine).
- *
- * o The mblk doesn't contain enough data to populate a simple IP header.
- */
-#define	MBLK_RX_FANOUT_SLOWPATH(mp, ipha)				\
-	(DB_TYPE(mp) != M_DATA ||					\
-	(DB_REF(mp) != 1) ||						\
-	!OK_32PTR(ipha) ||						\
-	(((uchar_t *)ipha + IP_SIMPLE_HDR_LENGTH) >= (mp)->b_wptr))
-
 /*
  * In non-global zone exclusive IP stacks, data structures such as IRE
  * entries pretend that they're in the global zone.  The following
